Index: /data/trunk/gui/looknfeel/TaharezGreenLook.looknfeel
===================================================================
--- /data/trunk/gui/looknfeel/TaharezGreenLook.looknfeel	(revision 7594)
+++ /data/trunk/gui/looknfeel/TaharezGreenLook.looknfeel	(revision 7595)
@@ -14,4 +14,7 @@
         <PropertyDefinition name="HorzLabelFormatting" initialValue="CentreAligned" />
         <PropertyDefinition name="NormalImage" initialValue="" redrawOnWrite="true" />
+        <PropertyDefinition name="NormalImageBackground" initialValue="set:TaharezGreenLook image:ButtonMiddleNormal" redrawOnWrite="true" />
+        <PropertyDefinition name="NormalImageRightEdge" initialValue="set:TaharezGreenLook image:ButtonRightNormal" redrawOnWrite="true" />
+        <PropertyDefinition name="NormalImageLeftEdge" initialValue="set:TaharezGreenLook image:ButtonLeftNormal" redrawOnWrite="true" />
         <PropertyDefinition name="HoverImage" initialValue="" redrawOnWrite="true" />
         <PropertyDefinition name="PushedImage" initialValue="" redrawOnWrite="true" />
@@ -32,15 +35,52 @@
         </ImagerySection>
         <ImagerySection name="normal">
-            <FrameComponent>
-                <Area>
-                    <Dim type="LeftEdge"><AbsoluteDim value="0" /></Dim>
-                    <Dim type="TopEdge"><AbsoluteDim value="0" /></Dim>
-                    <Dim type="Width"><UnifiedDim scale="1" type="Width" /></Dim>
-                    <Dim type="Height"><UnifiedDim scale="1" type="Height" /></Dim>
-                </Area>
-                <Image type="LeftEdge" imageset="TaharezGreenLook" image="ButtonLeftNormal" />
-                <Image type="RightEdge" imageset="TaharezGreenLook" image="ButtonRightNormal" />
-                <Image type="Background" imageset="TaharezGreenLook" image="ButtonMiddleNormal" />
-            </FrameComponent>
+            <ImageryComponent>
+                <Area>
+                    <Dim type="LeftEdge" >
+                        <AbsoluteDim value="0" >
+                            <DimOperator op="Add">
+                                <ImageDim imageset="TaharezGreenLook" image="ButtonLeftNormal" dimension="Width" />
+                            </DimOperator>
+                        </AbsoluteDim>
+                    </Dim>
+                    <Dim type="TopEdge" ><AbsoluteDim value="0" /></Dim>
+                    <Dim type="Width" >
+                        <UnifiedDim scale="1" type="Width">
+                            <DimOperator op="Subtract">
+                                <ImageDim imageset="TaharezGreenLook" image="ButtonLeftNormal" dimension="Width">
+                                    <DimOperator op="Add">
+                                        <ImageDim imageset="TaharezGreenLook" image="ButtonRightNormal" dimension="Width" />
+                                    </DimOperator>
+                                </ImageDim>
+                            </DimOperator>
+                        </UnifiedDim>
+                    </Dim>
+                    <Dim type="Height" ><UnifiedDim scale="1" type="Height" /></Dim>
+                </Area>
+                <ImageProperty name="NormalImageBackground" />
+                <VertFormatProperty name="VertImageFormatting" />
+                <HorzFormatProperty name="HorzImageFormatting" />
+            </ImageryComponent>
+            <ImageryComponent>
+                <Area>
+                    <Dim type="LeftEdge" ><AbsoluteDim value="0" /></Dim>
+                    <Dim type="TopEdge" ><AbsoluteDim value="0" /></Dim>
+                    <Dim type="Width" ><UnifiedDim scale="1" type="Width" /></Dim>
+                    <Dim type="Height" ><UnifiedDim scale="1" type="Height" /></Dim>
+                </Area>
+                <ImageProperty name="NormalImageRightEdge" />
+                <VertFormatProperty name="VertImageFormatting" />
+                <HorzFormat type="RightAligned" />
+            </ImageryComponent>
+            <ImageryComponent>
+                <Area>
+                    <Dim type="LeftEdge" ><AbsoluteDim value="0" /></Dim>
+                    <Dim type="TopEdge" ><AbsoluteDim value="0" /></Dim>
+                    <Dim type="Width" ><UnifiedDim scale="1" type="Width" /></Dim>
+                    <Dim type="Height" ><UnifiedDim scale="1" type="Height" /></Dim>
+                </Area>
+                <ImageProperty name="NormalImageLeftEdge" />
+                <VertFormatProperty name="VertImageFormatting" />
+            </ImageryComponent>
             <ImageryComponent>
                 <Area>
@@ -1765,5 +1805,6 @@
         <NamedArea name="ItemRenderingArea">
             <Area>
-                <Dim type="LeftEdge" ><ImageDim imageset="TaharezGreenLook" image="ListboxLeft" dimension="Width" /></Dim>
+                <Dim type="LeftEdge" ><ImageDim imageset="TaharezGreenLook" image="ListboxLeft" dimension
+="Width" /></Dim>
                 <Dim type="TopEdge" ><ImageDim imageset="TaharezGreenLook" image="ListboxTop" dimension="Height" /></Dim>
                 <Dim type="RightEdge" >