Index: code/trunk/src/modules/objects/triggers/MultiTrigger.h
===================================================================
--- code/trunk/src/modules/objects/triggers/MultiTrigger.h	(revision 7301)
+++ code/trunk/src/modules/objects/triggers/MultiTrigger.h	(revision 7601)
@@ -30,4 +30,5 @@
     @file MultiTrigger.h
     @brief Definition of the MultiTrigger class.
+    @ingroup MultiTrigger
 */
 
@@ -43,22 +44,15 @@
 #include <deque>
 
-#include "tools/interfaces/Tickable.h"
-#include "worldentities/StaticEntity.h"
+#include "TriggerBase.h"
 
 namespace orxonox
 {
 
-    //! The different modes the MultiTrigger can be in.
-    namespace MultiTriggerMode
-    {
-        enum Value
-        {
-            EventTriggerAND,
-            EventTriggerOR,
-            EventTriggerXOR,
-        };
-    }
-
-    //! Struct to handle MultiTrigger states internally.
+    /**
+    @brief
+    Struct to handle @ref orxonox::MultiTrigger "MultiTrigger" states internally.
+
+    @ingroup MultiTrigger
+    */
     struct MultiTriggerState
     {
@@ -70,26 +64,26 @@
     @brief
         The MultiTrigger class implements a trigger that has a distinct state for each object triggering it.
-        In more detail: A Trigger is an object that can either be active or inactive, with a specified behavior how to switch between the two. A MultiTrigger generalizes that behavior for multiple objects triggering the trigger. A MultiTrigger can be active or inactive for any object triggering it, with the state for each object being completely independent of the state for other objects. Each time a switch occurs an Event is fired with as the originator a MultiTriggerContainer, containing a pointer to the MultiTrigger that caused the Event and a pointer to the object that caused the trigger to change it's activity.
+        In more detail: A Trigger is an object that can either be <em>active</em> or <em>inactive</em>, with a specified behavior how to switch between the two. A MultiTrigger generalizes that behavior for multiple objects triggering the trigger. A MultiTrigger can be <em>active</em> or <em>inactive</em> for any object triggering it, with the state for each object being completely independent of the state for other objects. Each time a switch occurs an @ref orxonox::Event "Event" is fired with as the originator a @ref orxonox::MultiTriggerContainer "MultiTriggerContainer", containing a pointer to the MultiTrigger that caused the @ref orxonox::Event "Event" and a pointer to the object that caused the trigger to change it's activity.
 
         MultiTriggers also allow for additional complexity which can be added through the choice of the parameters explained (briefly) below:
-        But first you must understand a small implementational detail. There is a distinction between the MultiTrigger being triggered (there is the state 'triggered' for that) and the MultiTrigger being active (for that is the state 'activity'). From the outside only the activity is visible. The state 'triggered' tells us whether the trigger is actually triggered, but it could pretend (for some reason, some of which we will see shortly) to be triggered (or to the outside, active), while it in fact isn't. The standard behavior is, that the activity changes, when the MultiTrigger transits from being triggered to not being triggered or the other way around.
+        But first you must understand a small implementational detail. There is a distinction between the MultiTrigger being triggered (there is the state <em>triggered</em> for that) and the MultiTrigger being active (for that is the state <em>activity</em>). From the outside only the <em>activity</em> is visible. The state <em>triggered</em> tells us whether the trigger is actually triggered, but it could pretend (for some reason, some of which we will see shortly) to be triggered (or to the outside, active), while it in fact isn't. The standard behavior is, that the <em>activity</em> changes, when the MultiTrigger transits from being triggered to not being triggered or the other way around.
         The parameters are:
-            'delay':                    The delay is the time that the trigger waits until it reacts (i.e. changes it's state) to the triggering condition being fulfilled.
-            'switch':                   Switch is a bool, if true the MultiTrigger is in switch-mode, meaning, that the activity changes only when the trigger is triggered , this means, that now the activity only changes, when the trigger changes from not being triggered to being triggered but not the other way around. The default is false.
-            'stayactive':               Stay active is also a bool, if true the MultiTrigger stays active after it has been activated as many times as specified by the parameter activations. The default is false.
-            'activations':              The number of activations until the trigger can't be triggered anymore. The default is -1, which is infinity.
-            'invert':                   Invert is a bool, if true the trigger is in invert-mode, meaning, that if the triggering condition is fulfilled the MultiTrigger will have the state not triggered and and if the condition is not fulfilled it will have the state triggered. In short it just inverts the behavior of the MultiTrigger. The default is false.
-            'simultaneousTriggerers':   The number of simultaneous triggerers limits the number of objects that are allowed to trigger the MultiTrigger at the same time. Or more precisely, the number of distinct objects the MultiTrigger has 'triggered' states for, at each point in time. The default is -1, which denotes infinity.
-            'mode':                     The mode describes how the MultiTrigger acts in relation to all the MultiTriggers, that are appended to it. There are 3 modes: 'and', meaning that the MultiTrigger can only be triggered if all the appended MultiTriggers are active. 'or', meaning that the MultiTrigger can only triggered if at least one of the appended MultiTriggers is active. And 'xor', meaning that the MultiTrigger can only be triggered if one and only one appended MultiTrigger is active. Note, that I wrote 'can only be active', that implies, that there is an additional condition to the activity of the MultiTrigger and that is the fulfillment of the triggering condition (the MultiTrigger itself doesn't have one, but all derived classes should). Also bear in mind, that the activity of a MultiTrigger is still coupled to the object that triggered it. The default is 'and'.
-            'broadcast'                 Broadcast is a bool, if true the MutliTrigger is in broadcast-mode, meaning, that all trigger events that are caused by no originator (originator is NULL) are broadcast as having come from every possible originator, or more precisely as having come from all objects that are specified targets of this MultiTrigger. The default is false.
-            'target':                   The target describes the kind of objects that are allowed to trigger this MultiTrigger. The default is 'Pawn'.
-            Also there is the possibility of appending MultiTriggers to the MultiTrigger just by adding them as sub-objects in the XML description of your MultiTrigger.
+        - @b delay The delay is the time that the trigger waits until it reacts (i.e. changes it's state) to the triggering condition being fulfilled.
+        - @b switch Switch is a boolean, if true the MultiTrigger is in switch-mode, meaning, that the <em>activity</em> changes only when the trigger is triggered, this means, that now the <em>activity</em> only changes, when the trigger changes from not being triggered to being triggered but not the other way around. The default is false.
+        - @b stayactive Stay active is also a boolean, if true the MultiTrigger stays active after it has been activated as many times as specified by the parameter activations. The default is false.
+        - @b activations The number of activations until the trigger can't be triggered anymore. The default is -1, which is infinity.
+        - @b invert Invert is a boolean, if true the trigger is in <em>invert-mode</em>, meaning, that if the triggering condition is fulfilled the MultiTrigger will have the state not triggered and and if the condition is not fulfilled it will have the state triggered. In short it just inverts the behavior of the MultiTrigger. The default is false.
+        - @b simultaneousTriggerers The number of simultaneous triggerers limits the number of objects that are allowed to trigger the MultiTrigger at the same time. Or more precisely, the number of distinct objects the MultiTrigger has <em>triggered</em> states for, at each point in time. The default is -1, which denotes infinity.
+        - @b mode The mode describes how the MultiTrigger acts in relation to all the triggers, that are appended to it. There are 3 modes: <em>and</em>, meaning that the MultiTrigger can only be triggered if all the appended triggers are active. <em>or</em>, meaning that the MultiTrigger can only triggered if at least one of the appended triggers is active. And <em>xor</em>, meaning that the MultiTrigger can only be triggered if one and only one appended trigger is active. Note, that I wrote <em>can only be active</em>, that implies, that there is an additional condition to the activity of the MultiTrigger and that is the fulfillment of the triggering condition (the MultiTrigger itself doesn't have one, but all derived classes should). Also bear in mind, that the activity of a MultiTrigger is still coupled to the object that triggered it. The default is <em>and</em>.
+        - @b broadcast Broadcast is a boolean, if true the MutliTrigger is in <em>broadcast-mode</em>, meaning, that all trigger events that are caused by no originator (originator is NULL) are broadcast as having come from every possible originator, or more precisely as having come from all objects that are specified targets of this MultiTrigger. The default is false.
+        - @b target The target describes the kind of objects that are allowed to trigger this MultiTrigger. The default is @ref orxonox::Pawn "Pawn".
+        - Also there is the possibility of appending triggers (as long as they inherit from TriggerBase) to the MultiTrigger just by adding them as children in the XML description of your MultiTrigger.
 
         An example of a MultiTrigger created through XML would look like this:
         @code
         <MultiTrigger position="0,0,0" delay="1.3" switch="true" stayactive="true" activations="7" invert="true" simultaneousTriggerers="2" mode="xor" broadcast="false" target="Pawn">
-            <MultiTrigger />
+            <TriggerBase />
             ...
-            <MultiTrigger />
+            <TriggerBase />
         </MultiTrigger>
         @endcode
@@ -97,7 +91,10 @@
     @author
         Damian 'Mozork' Frick
-        Many concepts and loads of inspiration from the Trigger class by Benjamin Knecht.
+
+        Many concepts and loads of inspiration from the @ref orxonox::Trigger "Trigger" class by Benjamin Knecht.
+
+    @ingroup MultiTrigger
     */
-    class _ObjectsExport MultiTrigger : public StaticEntity, public Tickable
+    class _ObjectsExport MultiTrigger : public TriggerBase
     {
         public:
@@ -108,51 +105,11 @@
             virtual void tick(float dt); //!< A method that is executed each tick.
 
-            bool isActive(BaseObject* triggerer = NULL); //!< Get whether the MultiTrigger is active for a given object.
-
-            /**
-            @brief Set the delay of the MultiTrigger.
-            @param delay The delay to be set.
-            */
-            inline void setDelay(float delay)
-                { if(delay > 0.0f) this->delay_= delay; }
-            /**
-            @brief Get the delay of the MultiTrigger.
-            @return The delay.
-            */
-            inline float getDelay(void) const
-                { return this->delay_; }
-
-            /**
-            @brief Set switch-mode of the MultiTrigger.
-            @param bSwitch If true the MultiTrigger is set to switched.
-            */
-            inline void setSwitch(bool bSwitch)
-                { this->bSwitch_ = bSwitch; }
-            /**
-            @brief Get the switch-mode of the MultiTrigger.
-            @return Returns true if the MultiTriger is in switch-mode.
-            */
-            inline bool getSwitch(void) const
-                { return this->bSwitch_; }
-
-            /**
-            @brief Set the stay-active-mode of the MultiTrigger.
-            @param bStayActive If true the MultiTrigger is set to stay active.
-            */
-            inline void setStayActive(bool bStayActive)
-                { this->bStayActive_ = bStayActive; }
-            /**
-            @brief Get the stay-active-mode of the MultiTrigger.
-            @return Returns true if the MultiTrigger stays active.
-            */
-            inline bool getStayActive(void) const
-                { return this->bStayActive_; }
-
-            /**
-            @brief Get the number of remaining activations of the MultiTrigger.
-            @return The number of activations. -1 denotes infinity.
-            */
-            inline int getActivations(void) const
-                { return this->remainingActivations_; }
+            /**
+            @brief Check whether the MultiTrigger is active.
+            @return Returns if the MultiTrigger is active.
+            */
+            inline bool isActive(void) const
+                { return this->isActive(NULL); }
+            bool isActive(BaseObject* triggerer = NULL) const; //!< Get whether the MultiTrigger is active for a given object.
 
             /**
@@ -161,5 +118,5 @@
             */
             inline void setSimultaneousTriggerers(int triggerers)
-                { if(triggerers >= 0 || triggerers == INF_s) this->maxNumSimultaneousTriggerers_ = triggerers; }
+                { if(triggerers >= 0 || triggerers == TriggerBase::INF_s) this->maxNumSimultaneousTriggerers_ = triggerers; }
             /**
             @brief Get the number of objects that are allowed to simultaneously trigger this MultiTriggger.
@@ -168,32 +125,4 @@
             inline int getSimultaneousTriggerers(void)
                 { return this->maxNumSimultaneousTriggerers_; }
-
-            /**
-            @brief Set the invert-mode of the MultiTrigger.
-            @param bInvert If true the MultiTrigger is set to invert.
-            */
-            inline void setInvert(bool bInvert)
-                { this->bInvertMode_ = bInvert; }
-            /**
-            @brief Get the invert-mode of the MultiTrigger.
-            @return Returns true if the MultiTrigger is set to invert.
-            */
-            inline bool getInvert(void) const
-                { return this->bInvertMode_; }
-
-            void setMode(const std::string& modeName); //!< Set the mode of the MultiTrigger.
-            /**
-            @brief Set the mode of the MultiTrigger.
-            @param mode The mode of the MultiTrigger.
-            */
-            inline void setMode(MultiTriggerMode::Value mode) //!< Get the mode of the MultiTrigger.
-                { this->mode_ = mode; }
-            const std::string& getModeString(void) const;
-            /**
-            @brief Get the mode of the MultiTrigger.
-            @return Returns and Enum for the mode of the MultiTrigger.
-            */
-            inline MultiTriggerMode::Value getMode() const
-                { return mode_; }
 
             /**
@@ -218,7 +147,4 @@
                 { if(target == NULL) return true; else return targetMask_.isIncluded(target->getIdentifier()); }
 
-            void addTrigger(MultiTrigger* trigger); //!< Adds a MultiTrigger as a sub-trigger to the trigger.
-            const MultiTrigger* getTrigger(unsigned int index) const; //!< Get the sub-trigger of this MultiTrigger at the given index.
-
         protected:
             virtual std::queue<MultiTriggerState*>* letTrigger(void); //!< This method is called by the MultiTrigger to get information about new trigger events that need to be looked at.
@@ -226,5 +152,5 @@
             void changeTriggered(BaseObject* originator = NULL); //!< This method can be called by any class inheriting from MultiTrigger to change it's triggered status for a specified originator.
 
-            bool isModeTriggered(BaseObject* triggerer = NULL); //!< Checks whetherx the MultiTrigger is triggered concerning it's sub-triggers.
+            bool isModeTriggered(BaseObject* triggerer = NULL); //!< Checks whether the MultiTrigger is triggered concerning it's children.
             bool isTriggered(BaseObject* triggerer = NULL); //!< Get whether the MultiTrigger is triggered for a given object.
 
@@ -232,22 +158,8 @@
             void broadcast(bool status); //!< Helper method. Broadcasts an Event for every object that is a target.
 
-            /**
-            @brief Set the number of activations the MultiTrigger can go through.
-            @param activations The number of activations. -1 denotes infinitely many activations.
-            */
-            inline void setActivations(int activations)
-                { if(activations >= 0 || activations == INF_s) this->remainingActivations_ = activations; }
-
             void addTargets(const std::string& targets); //!< Add some target to the MultiTrigger.
             void removeTargets(const std::string& targets); //!< Remove some target from the MultiTrigger.
 
             /**
-            @brief Adds the parent of a MultiTrigger.
-            @param parent A pointer to the parent MultiTrigger.
-            */
-            inline void addParentTrigger(MultiTrigger* parent)
-                { this->parentTrigger_ = parent; }
-
-            /**
             @brief Get the target mask used to identify the targets of this MultiTrigger.
             @return Returns the target mask.
@@ -257,17 +169,11 @@
 
         private:
-            static const int INF_s; //!< Magic number for infinity.
-            //! Magic strings for the mode.
-            static const std::string and_s;
-            static const std::string or_s;
-            static const std::string xor_s;
-
-            void subTriggerActivityChanged(BaseObject* originator); //!< This method is called by any sub-trigger to advertise changes in it's state to it's parent-trigger.
+            void childActivityChanged(BaseObject* originator); //!< This method is called by any child to advertise changes in it's state to it's parent.
 
             bool addState(MultiTriggerState* state); //!< Helper method. Adds a state to the state queue, where the state will wait to become active.
 
-            bool checkAnd(BaseObject* triggerer); //!< Checks whether the sub-triggers amount to true for the 'and' mode for a given object.
-            bool checkOr(BaseObject* triggerer); //!< Checks whether the sub-triggers amount to true for the 'or' mode for a given object.
-            bool checkXor(BaseObject* triggerer); //!< Checks whether the sub-triggers amount to true for the 'xor' mode for a given object.
+            bool checkAnd(BaseObject* triggerer); //!< Checks whether the children amount to true for the <em>and</em> mode for a given object.
+            bool checkOr(BaseObject* triggerer); //!< Checks whether the children amount to true for the <em>or</em> mode for a given object.
+            bool checkXor(BaseObject* triggerer); //!< Checks whether the children amount to true for the <em>xor</em> mode for a given object.
 
             /**
@@ -278,20 +184,7 @@
                 { return this->active_; }
 
-            bool bFirstTick_; //!< Bool to distinguish the first tick form all the following.
-
-            float delay_; //!< The delay that is imposed on all new trigger events.
-            bool bSwitch_; //!< Bool for the switch-mode, if true the MultiTrigger behaves like a switch.
-            bool bStayActive_; //!< Bool for the stay-active-mode, if true the MultiTrigger stays active after its last activation.;
-
-            int remainingActivations_; //!< The remaining activations of this MultiTrigger.
             int maxNumSimultaneousTriggerers_; //!< The maximum number of objects simultaneously trigggering this MultiTrigger.
 
-            bool bInvertMode_; //!< Bool for the invert-mode, if true the MultiTrigger is inverted.
-            MultiTriggerMode::Value mode_; //!< The mode of the MultiTrigger.
-
             bool bBroadcast_; //!< Bool for the broadcast-mode, if true all triggers go to all possible targets.
-
-            MultiTrigger* parentTrigger_; //!< The parent-trigger of theis MultiTrigger.
-            std::set<MultiTrigger*> subTriggers_; //!< The sub-triggers of this MultiTrigger.
 
             std::set<BaseObject*> active_; //!< The set of all objects the MultiTrigger is active for.